# bbi_paths.lib
Version=3.5.0

#==============================================================================
# Copyright and license info is available in the LICENSE file included with
# the P4BBI tool, and also available online:
# https://swarm.workshop.perforce.com/projects/perforce-software-baseline-and-branch-import/view/main/LICENSE
#------------------------------------------------------------------------------

#==============================================================================
# BBI Library Functions.

#------------------------------------------------------------------------------
# Function: get_stream_subdir ($path)
# Given:                             Return:
#    //stream/main/...               "" (empty)
#    //stream/main/ACE/...           ACE
#    //stream/main/ACE/d1/d2/...     ACE/d1/d2

function get_stream_subdir () {
   # Write debug to stderr to avoid corrupting return value on stdout.
   [[ $VERBOSITY -ge 3 ]] && echo "CALL: get_stream_subdir ($*)" >&2
   declare p=${1/\/.../\/}
   p=${p#//*/*/}
   echo ${p%/}
}

#------------------------------------------------------------------------------
# Function: get_stream ($path)
# Given:                             Return:
#    //stream/main/...               //stream/main
#    //stream/main/ACE/...           //stream/main
#    //stream/main/ACE/d1/d2/...     //stream/main
#    //stream/main                   //stream/main

function get_stream () {
   # Write debug to stderr to avoid corrupting return value on stdout.
   [[ $VERBOSITY -ge 3 ]] && echo "CALL: get_stream ($*)" >&2
   declare p=$(echo $1 | sed "s:/:\::g")
   echo "//$(echo $p|cut -d ':' -f 3)/$(echo $p|cut -d ':' -f 4)"
}
