#!/bin/bash

declare -i OverallReturnStatus=0
declare -i ExitCode=
declare Version=3.5.1

cd ${P4BBI_HOME:-/p4/p4bbi} || exit 1
source env.sh
P4="$P4BIN -u p4import -p $TestP4PORT"
cd sample_cfg || exit 1

echo -e "Started $0 v$Version at $(date)."

$P4BBI_HOME/test/start_p4d.sh reset || exit 1

Cmd="$P4BBI_SCRIPT -R -J -c FGS.Classic.bbi.cfg -P $PWD/p4config.test -L off $*"
echo -e "Running: $Cmd\n"
$Cmd
ExitCode=$?
echo TEST_EXIT_CODE=$ExitCode
OverallReturnStatus=$((OverallReturnStatus+ExitCode))

Cmd="$P4BBI_SCRIPT -R -J -c FGS.Streams.bbi.cfg -P $PWD/p4config.test -L off $*"
echo -e "Running: $Cmd\n"
$Cmd
ExitCode=$?
echo TEST_EXIT_CODE=$ExitCode
OverallReturnStatus=$((OverallReturnStatus+ExitCode))

Cmd="$P4BBI_SCRIPT -J -c perl6-examples.bbi.cfg -P $PWD/p4config.test -L off $*"
echo -e "Running: $Cmd\n"
$Cmd
ExitCode=$?
echo TEST_EXIT_CODE=$ExitCode
OverallReturnStatus=$((OverallReturnStatus+ExitCode))

Cmd="$P4BBI_SCRIPT -c SymlinkRefactoring.bbi.cfg -P $PWD/p4config.test -L off $*"
echo -e "Running: $Cmd\n"
$Cmd
ExitCode=$?
echo TEST_EXIT_CODE=$ExitCode
OverallReturnStatus=$((OverallReturnStatus+ExitCode))

# For demo convenience, create a workspace.
echo -e "Client:\tp4import_ws\n\nOwner:\tp4import\n\nDescription:\n\tCreated by p4import.\n\nRoot:\t$PWD/ws\n\nOptions:\tnoallwrite clobber nocompress unlocked modtime rmdir\n\nSubmitOptions:\tleaveunchanged\n\nLineEnd:\tlocal\n\nView:\n\t//ImportTest/... //p4import_ws/...\n\n" | $P4 -s client -i

echo -e "That took $(($SECONDS/3600)) hours $(($SECONDS%3600/60)) minutes $(($SECONDS%60)) seconds.\n"
